// TODO chess, rows are called 'files' and columns are called 'ranks'

export class Position {

    static from(move) {
        if (move.length != 2 && move.length != 4) {
            return null
        }

        const position = {
            column: move[0].charCodeAt() - 'a'.charCodeAt(),
            row: 7 - move[1]
        }

        return position
    }

    static to(position) {
        const move = String.fromCharCode(position.row + 'a'.charCodeAt()) + (position.column - 1)
        return move     // SAN piece
    }

    static isValid(position) {
        // TODO
    }
}