// pretty untested


// panel with live game list (player1, player2, timestamp, result, moves)

// TODO ELO
// TODO JSON

export class LiveView {

    // TODO i guess $figure is not needed if we callback with errors (const error = await plugin.open() / $flash = error in main()))
    constructor($figure, url) {
        this.url = url
    }

    static understands(url) {
        return url.startsWith('wss://')
    }

    async open() {
    // var ws = new WebSocket('wss://server.ataxx.org/ws/viewer?p1=' + encodeURIComponent(p1) + '&p2=' + encodeURIComponent(p2));
        //        const url = `${ url }?p1=${ encodeURIComponent(player1.trim()) }&p2=${ encodeURIComponent(player2.trim()) }`


        const ws = new WebSocket(this.url);

        ws.addEventListener('open', () => {
            const params = new URLSearchParams(document.location.search)

            // see incorrect plus in http://server.ataxx.org/liveviewer.php?p1=sashaxxx-rpi3b+&p2=funes-rpi3b
            // what about space within player names? -> encoreuricomponent

            // send a bogus message to be notified of new games (message type 'new_pair')

        // no effect, you have to reopen the ws again (although i heard that it work noaways, test it!)
//        ws.send(`${ player1 }|${ player2 }`)

            const [player1, player2] = [
            params.get('p1') || '',
            params.get('p2') || ''
            ]
            ws.send(`${ encodeURIComponent(player1.trim()) }|${ encodeURIComponent(player2.trim()) }`)
        })

        ws.addEventListener('close', e => {
            console.warn('websocket closed', e)
            const $flash = $figure.querySelector('.flash')
            $flash.innnerHTML = e
        })

        ws.addEventListener('message', e => {
            const tokens = e.data.split(' ')
            // fen x6/7/3xo2/xxoxoo1/xxoxxx1/xx2x2/xoo4 o 3 20 c2a4 1572900627.156150
            const [ type ] = tokens

            switch (type) {
                case 'fen':
                    const [, fen, color, moveOrHalfMoveNumber, moveNumber, move, moveTimestamp] = tokens
                    console.log('[liveview]', { fen, color, moveOrHalfMoveNumber, moveNumber, move, moveTimestamp: new Date(moveTimestamp * 1000) })
                    break

                case 'msg':
                    const [, ...message] = tokens
                    console.log('[liveview]', { message: message.join(' ') })
                    break

                case 'new_pair':
                    const [, player1, player2, newGameTimeStamp] = tokens
                    console.log('[liveview]', { player1, player2, timestamp: new Date(newGameTimeStamp * 1000) })

                    // no effect, you have to reopen the ws again (although i heard that it work nowadays, test it!)
                    // ws.send(`${player1}|${player2}`)

                    // const href = `?url=${encodeURIComponent(url)}&p1=${encodeURIComponent(player1)}&p2=${encodeURIComponent(player2)}`
                    // log(`<a href="${href}">${href}</a>`)
                    break

                default:
                    console.warn(`[liveview] unknown type ${type}`)
            }
        })

        ws.addEventListener('error', e => {
            console.error(e)
            const $flash = $figure.querySelector('.flash')
            $flash.innnerHTML = e
        // reconnect fibonacci seconds
        })
    }

}
